#!/bin/sh

# Check for library files
if test ! -f lib/freenet.jar; then
  echo lib/freenet.jar not found.  You must run "make jar" before running 
  echo Freenet.
  exit
fi

if test ! -f lib/freenet-ext.jar; then
  echo lib/freenet-ext.jar not found.  It can be downloaded from
  echo http://freenetproject.org/snapshots/freenet-ext.jar
  exit
fi

CLASSPATH=lib/freenet.jar:lib/freenet-ext.jar:$CLASSPATH 
export CLASSPATH
# why are we permanently altering the environment?
# because bourne shell needs it!


if test ! -f seednodes.ref; then
  echo seednodes.ref not found, would you like to download some seeds
  echo from http://hawk.freenetproject.org/~freenet4/seednodes.ref?
  echo -n "[y/N] "
  read resp
  if test $resp = "y" -o $resp = "Y"; then
    wget http://hawk.freenetproject.org/~freenet4/seednodes.ref
  fi
fi

if test ! -f freenet.conf; then
  echo "No freenet.conf file found.  Running auto-config."
  if test -f scripts/preconfig.sh; then
    ./scripts/preconfig.sh
  else
    ./preconfig.sh
  fi
  java freenet.node.Main --config
  echo "Running Freenet..."
fi

java freenet.node.Main $@ &
echo $! > freenet.pid
